org.apache.xmlbeans

## Interface XmlFactoryHook

    public interface XmlFactoryHook

A hook for the XML Bean Factory mechanism. Provided for advanced users who wish to provide their own implementation of the Factory.parse methods. This is used, for example, to defer reading XML streams until needed.

To use the hook, call XmlFactoryHook.ThreadContext.setHook(), passing your own XmlFactoryHook implementation. Then every call to a Factory method will be delgated to your hook.

     MyHook hook = new MyHook();
     XmlFactoryHook.ThreadContext.setHook(hook);
     // this results in a call to hook.parse(...)
     XmlObject.Factory.parse(new File("test.xml"));

If the hook needs to turn around and invoke the built-in parsers, then it should do so by calling the appropriate method on the passed SchemaTypeLoader. Since SchemaTypeLoader.parse() methods delegate to the registered hook, a hook that wishes to actually invoke the default parser without having itself called back again should unregister itself before calling loader.parse(), and then re-register itself again after the call.

     void parse(SchemaTypeLoader loader, ...)
     {
         XmlFactoryHook remember = XmlFactoryHook.ThreadContext.getHook();
         XmlFactoryHook.ThreadContext.setHook(null);
         loader.parse(...); // isn't hooked.
         XmlFactoryHook.ThreadContext.setHook(remember);
     }

### Nested Class Summary

Nested Classes
`static class` `XmlFactoryHook.ThreadContext` Used to manage the XmlFactoryHook for the current thread.

### Method Summary

All Methods Instance Methods Abstract Methods
`DOMImplementation` `newDomImplementation(SchemaTypeLoader loader, XmlOptions options)` Hooks Factory.newDomImplementation calls
`XmlObject` `newInstance(SchemaTypeLoader loader, SchemaType type, XmlOptions options)` Hooks Factory.newInstance calls
`XmlSaxHandler` `newXmlSaxHandler(SchemaTypeLoader loader, SchemaType type, XmlOptions options)` Hooks Factory.newXmlSaxHandler calls
`XmlObject` `parse(SchemaTypeLoader loader, InputStream jiois, SchemaType type, XmlOptions options)` Hooks Factory.parse calls
`XmlObject` `parse(SchemaTypeLoader loader, Node node, SchemaType type, XmlOptions options)` Hooks Factory.parse calls
`XmlObject` `parse(SchemaTypeLoader loader, Reader jior, SchemaType type, XmlOptions options)` Hooks Factory.parse calls
`XmlObject` `parse(SchemaTypeLoader loader, String xmlText, SchemaType type, XmlOptions options)` Hooks Factory.parse calls
`XmlObject` `parse(SchemaTypeLoader loader, XMLStreamReader xsr, SchemaType type, XmlOptions options)` Hooks Factory.parse calls

### Method Detail

#### newInstance

    XmlObject newInstance(SchemaTypeLoader loader,
                          SchemaType type,
                          XmlOptions options)

Hooks Factory.newInstance calls

#### parse

    XmlObject parse(SchemaTypeLoader loader,
                    String xmlText,
                    SchemaType type,
                    XmlOptions options)
             throws XmlException

Hooks Factory.parse calls

Throws:
  `XmlException`

#### parse

    XmlObject parse(SchemaTypeLoader loader,
                    InputStream jiois,
                    SchemaType type,
                    XmlOptions options)
             throws XmlException,
                    IOException

Hooks Factory.parse calls

Throws:
  `XmlException`
  `IOException`

#### parse

    XmlObject parse(SchemaTypeLoader loader,
                    XMLStreamReader xsr,
                    SchemaType type,
                    XmlOptions options)
             throws XmlException

Hooks Factory.parse calls

Throws:
  `XmlException`

#### parse

    XmlObject parse(SchemaTypeLoader loader,
                    Reader jior,
                    SchemaType type,
                    XmlOptions options)
             throws XmlException,
                    IOException

Hooks Factory.parse calls

Throws:
  `XmlException`
  `IOException`

#### parse

    XmlObject parse(SchemaTypeLoader loader,
                    Node node,
                    SchemaType type,
                    XmlOptions options)
             throws XmlException

Hooks Factory.parse calls

Throws:
  `XmlException`

#### newXmlSaxHandler

    XmlSaxHandler newXmlSaxHandler(SchemaTypeLoader loader,
                                   SchemaType type,
                                   XmlOptions options)

Hooks Factory.newXmlSaxHandler calls

#### newDomImplementation

    DOMImplementation newDomImplementation(SchemaTypeLoader loader,
                                           XmlOptions options)

Hooks Factory.newDomImplementation calls